Index: palm/trunk/TUTORIALS/cases/flow_around_cube_noncyclic/MONITORING/flow_around_cube_noncyclic_rc.000
===================================================================
--- palm/trunk/TUTORIALS/cases/flow_around_cube_noncyclic/MONITORING/flow_around_cube_noncyclic_rc.000	(revision 4446)
+++ palm/trunk/TUTORIALS/cases/flow_around_cube_noncyclic/MONITORING/flow_around_cube_noncyclic_rc.000	(revision 4765)
@@ -1,9 +1,9 @@
 
  ******************************    --------------------------------------------
- * PALM 6.0  Rev: 4402        *    atmosphere - run with cyclic fill of 3D - prerun data
+ * PALM 6.0  Rev: 4761        *    atmosphere - run with cyclic fill of 3D - prerun data
  ******************************    --------------------------------------------
 
- Date:               2020-02-12    Run:       flow_around_cube_noncyclic__gfortr
- Time:                 14:18:44    Run-No.:   00
+ Date:               2020-10-29    Run:       flow_around_cube_noncyclic__gfortr
+ Time:                 11:48:23    Run-No.:   00
  Run on host:        gfortran_d
  Number of PEs:               4    Processor grid (x,y): (   2,   2) calculated
@@ -13,5 +13,5 @@
  -----------------
 
- --> Use the Moeng_Wyngaard turbulence closure (LES mode).
+ --> Use the 1.5-order turbulence closure (LES mode).
  --> Use the boussinesq approximation for the model equations.
  --> Solve perturbation pressure via multigrid method (w-cycle)
@@ -93,5 +93,5 @@
 
        z_mo =   1.00 m   z0 = 0.1000 m   z0h = 0.10000 m   kappa = 0.40
-       Rif value range:     -20.00 <= rif <= 20.00
+       zeta value range:     -20.00 <= zeta <= 20.00
        Predefined surface temperature
 
@@ -204,5 +204,5 @@
  ---------------------------
 
-    Mixing length is limited to 1.80 * z
+    Mixing length is limited close to surfaces
 
 
@@ -243,43 +243,43 @@
   0    948 00:18:00.22   1.0500A   1.7116  -1.1300   1.4921  0.066  0.00   0.000E+00      0.  0.411E+00  0.820E-01  0.153E-02  0.892E-04   27   0  49    2   8  49   20  16  49    0.000    0.000       2
   0   1007 00:19:00.08   1.0100A   1.7782   1.2371   1.5253  0.069  0.00   0.000E+00      0.  0.410E+00  0.828E-01  0.154E-02  0.985E-04   28  39  63    2  32  49   20  18  49    0.000    0.000       2
-  0   1066 00:20:00.07   0.9800A   1.8375   0.8980   1.3451  0.067  0.00   0.000E+00      0.  0.413E+00  0.853E-01  0.143E-02  0.706E-04   29  39  11    1  36  50   20  14  49    0.000    0.000       2
-  0   1127 00:21:00.49   0.9420A   1.9448   0.8400   1.3591  0.064  0.00   0.000E+00      0.  0.412E+00  0.877E-01  0.151E-02  0.839E-04   35  38  79    4  28  43   20  23  49    0.000    0.000       2
-  0   1189 00:22:00.50   0.9850A   1.8279   1.2066   1.2944  0.068  0.00   0.000E+00      0.  0.422E+00  0.952E-01  0.153E-02  0.847E-04   34  38   4    4  32  49   20  26  49    0.000    0.000       2
+  0   1066 00:20:00.07   0.9800A   1.8376   0.8980   1.3451  0.067  0.00   0.000E+00      0.  0.413E+00  0.853E-01  0.143E-02  0.706E-04   29  39  11    1  36  50   20  14  49    0.000    0.000       2
+  0   1127 00:21:00.49   0.9430A   1.9448   0.8399   1.3592  0.064  0.00   0.000E+00      0.  0.412E+00  0.877E-01  0.151E-02  0.839E-04   35  38  79    4  28  43   20  23  49    0.000    0.000       2
+  0   1189 00:22:00.50   0.9850A   1.8279   1.2066   1.2943  0.068  0.00   0.000E+00      0.  0.422E+00  0.952E-01  0.153E-02  0.847E-04   34  38   4    4  32  49   20  26  49    0.000    0.000       2
   0   1249 00:23:00.32   0.9640A   1.8673   1.1792   1.5219  0.065  0.00   0.000E+00      0.  0.418E+00  0.901E-01  0.158E-02  0.107E-03   31   0   0    2  32  49   20  14  49    0.000    0.000       2
-  0   1309 00:24:00.41   1.0200A   1.7685   1.0823   1.3411  0.066  0.00   0.000E+00      0.  0.418E+00  0.897E-01  0.172E-02  0.886E-04   31   4   6    2  32  49   20  15  49    0.000    0.000       2
-  0   1369 00:25:00.60   1.0100A   1.7924   1.1281   1.5216  0.068  0.00   0.000E+00      0.  0.410E+00  0.846E-01  0.177E-02  0.113E-03   25  39   0    4  31  49   20  26  49    0.000    0.000       2
-  0   1428 00:26:00.51   1.0000A   1.7920   1.0523   1.2578  0.080  0.00   0.000E+00      0.  0.414E+00  0.892E-01  0.170E-02  0.910E-04   17   7  58    2  31  49   20  24  49    0.000    0.000       2
-  0   1488 00:27:00.16   0.9830A   1.8315   1.0459   1.2955  0.080  0.00   0.000E+00      0.  0.410E+00  0.839E-01  0.150E-02  0.919E-04   30   0  56    2  33  49   20  13  49    0.000    0.000       2
-  0   1549 00:28:00.84   1.0200A   1.7585   1.2787   1.1722  0.080  0.00   0.000E+00      0.  0.411E+00  0.861E-01  0.155E-02  0.895E-04   37  35  14   17  22  49   20  19  49    0.000    0.000       2
-  0   1607 00:29:00.72   1.0800A   1.7528   1.0562   1.3318  0.069  0.00   0.000E+00      0.  0.413E+00  0.907E-01  0.174E-02  0.111E-03   29   2  78    7  31  49   20  18  49    0.000    0.000       2
-  0   1664 00:30:00.31   1.0200A   1.7642   1.0976   1.3301  0.069  0.00   0.000E+00      0.  0.415E+00  0.892E-01  0.161E-02  0.927E-04   11   5  74   13  31  49   20  13  49    0.000    0.000       2
-  0   1721 00:31:00.72   1.0300A   1.7429   1.0532   1.4061  0.064  0.00   0.000E+00      0.  0.414E+00  0.894E-01  0.169E-02  0.919E-04   24   2  60    5  27  49   20  17  49    0.000    0.000       2
-  0   1778 00:32:00.68   1.0600A   1.6955   1.0140   1.2614  0.077  0.00   0.000E+00      0.  0.412E+00  0.898E-01  0.169E-02  0.912E-04   21   0   0    2  32  49   20  25  49    0.000    0.000       2
-  0   1835 00:33:00.08   0.9730A   1.8504   1.1274   1.3873  0.069  0.00   0.000E+00      0.  0.410E+00  0.900E-01  0.160E-02  0.937E-04   21  12  50    2  32  49   20  13  49    0.000    0.000       2
-  0   1895 00:34:00.06   0.9810A   1.8349   0.9443   1.2642  0.075  0.00   0.000E+00      0.  0.419E+00  0.965E-01  0.140E-02  0.797E-04   29   0  56    9  30  49   20  20  49    0.000    0.000       2
-  0   1957 00:35:00.66   0.9550A   1.8920   1.0817   1.3552  0.073  0.00   0.000E+00      0.  0.418E+00  0.983E-01  0.137E-02  0.824E-04   23   1  78    2  31  49   20  16  49    0.000    0.000       2
-  0   2019 00:36:00.55   0.9240A   1.9916   1.0752   1.2718  0.068  0.00   0.000E+00      0.  0.425E+00  0.104E+00  0.137E-02  0.768E-04   36   1  78    2  31  49   20  18  49    0.000    0.000       2
-  0   2082 00:37:00.54   1.0100A   1.7937   0.8756   1.5066  0.067  0.00   0.000E+00      0.  0.422E+00  0.102E+00  0.160E-02  0.923E-04   30   2  78   14  19  49   20  13  49    0.000    0.000       2
-  0   2143 00:38:00.26   0.9800A   1.8370   0.8853   1.1871  0.074  0.00   0.000E+00      0.  0.428E+00  0.107E+00  0.154E-02  0.750E-04   38   4  78    2  30  47   20  27  49    0.000    0.000       2
-  0   2203 00:39:00.12   0.9610A   1.8728   1.0712   1.4166  0.071  0.00   0.000E+00      0.  0.427E+00  0.106E+00  0.155E-02  0.732E-04   27   1  11    2  31  49   20  12  49    0.000    0.000       2
-  0   2267 00:40:00.44   0.9290A   1.9374   0.9808   1.4697  0.072  0.00   0.000E+00      0.  0.431E+00  0.112E+00  0.160E-02  0.851E-04   26   1  57    2  32  49   20  14  49    0.000    0.000       2
-  0   2331 00:41:00.43   0.8880A   2.0266   1.3306   1.4416  0.070  0.00   0.000E+00      0.  0.436E+00  0.117E+00  0.162E-02  0.786E-04   27   2   3    2  32  49   20  19  49    0.000    0.000       2
-  0   2398 00:42:00.05   0.8940A   2.0248  -0.9421   1.1962  0.072  0.00   0.000E+00      0.  0.436E+00  0.115E+00  0.165E-02  0.659E-04   33   4  79   16   9  49   24  19  49    0.000    0.000       2
-  0   2464 00:43:00.53   0.9080A   1.9820   0.8949   1.1313  0.072  0.00   0.000E+00      0.  0.433E+00  0.111E+00  0.160E-02  0.587E-04   34   5   5    7  21  49   20  27  49    0.000    0.000       2
-  0   2533 00:44:00.94   0.9460A   1.9032   1.0644   1.2802  0.077  0.00   0.000E+00      0.  0.436E+00  0.114E+00  0.166E-02  0.742E-04   31   0  13    2  31  49   20  16  49    0.000    0.000       2
-  0   2596 00:45:00.53   0.9420A   1.9114  -1.0002   1.2925  0.085  0.00   0.000E+00      0.  0.434E+00  0.111E+00  0.161E-02  0.620E-04   26  39   0    5  21  49   20  26  49    0.000    0.000       2
-  0   2658 00:46:00.26   0.9910A   1.8216  -0.8775   1.2964  0.081  0.00   0.000E+00      0.  0.431E+00  0.108E+00  0.173E-02  0.664E-04   24  39  78   22  14  55   15  20  47    0.000    0.000       2
-  0   2720 00:47:00.12   1.0000A   1.8434   1.0204   1.3853  0.077  0.00   0.000E+00      0.  0.428E+00  0.106E+00  0.171E-02  0.785E-04   26   3  78    7  31  49   20  25  49    0.000    0.000       2
-  0   2781 00:48:00.79   1.0200A   1.7721  -0.8587   1.2322  0.076  0.00   0.000E+00      0.  0.424E+00  0.104E+00  0.167E-02  0.701E-04    9   2  52   14   9  49   20  19  49    0.000    0.000       2
-  0   2841 00:49:00.16   0.9050A   1.9906   0.9826   1.2308  0.080  0.00   0.000E+00      0.  0.427E+00  0.107E+00  0.141E-02  0.678E-04   25  38  79   10  30  49   20  25  49    0.000    0.000       2
-  0   2907 00:50:00.12   0.8990A   2.0012   1.2427   1.2314  0.078  0.00   0.000E+00      0.  0.437E+00  0.116E+00  0.143E-02  0.716E-04   23  38  53    2  32  49   29  19  51    0.000    0.000       2
-  0   2973 00:51:00.21   0.8740A   2.0601  -0.8411   1.3069  0.075  0.00   0.000E+00      0.  0.438E+00  0.119E+00  0.155E-02  0.679E-04   27  39   0    8  19  49   20  15  49    0.000    0.000       2
-  0   3041 00:52:00.57   0.8930A   2.0156   1.0215   1.2257  0.073  0.00   0.000E+00      0.  0.439E+00  0.116E+00  0.154E-02  0.561E-04   28   1  40   17  17  49   20  14  49    0.000    0.000       2
-  0   3108 00:53:00.72   0.8950A   2.0109  -0.7871   1.3200  0.074  0.00   0.000E+00      0.  0.435E+00  0.112E+00  0.143E-02  0.677E-04   35  38  31    6  11  45   20  11  49    0.000    0.000       2
-  0   3177 00:54:00.44   0.9100A   1.9790  -0.9421   1.3035  0.075  0.00   0.000E+00      0.  0.437E+00  0.110E+00  0.150E-02  0.762E-04   35  39  38   11   9  49   20  26  49    0.000    0.000       2
-  0   3243 00:55:00.53   0.9220A   1.9519   1.0650   1.0968  0.069  0.00   0.000E+00      0.  0.434E+00  0.107E+00  0.143E-02  0.616E-04   30  38  31   18  21  49   20  19  49    0.000    0.000       2
-  0   3307 00:56:00.10   0.9150A   2.0099   0.9078   1.3097  0.073  0.00   0.000E+00      0.  0.431E+00  0.108E+00  0.149E-02  0.751E-04   30  39  78   17  21  37   20  23  49    0.000    0.000       2
-  0   3373 00:57:00.52   0.9080A   1.9834  -1.1107   1.3413  0.073  0.00   0.000E+00      0.  0.425E+00  0.103E+00  0.151E-02  0.712E-04   22  39  53    2   8  49   20  14  49    0.000    0.000       2
-  0   3439 00:58:00.40   0.9580A   1.8780   0.9020   1.3022  0.066  0.00   0.000E+00      0.  0.425E+00  0.990E-01  0.147E-02  0.653E-04   11  38  53   17  31  47   20  16  49    0.000    0.000       2
-  0   3502 00:59:00.12   0.9620A   1.8708  -1.0457   1.3098  0.067  0.00   0.000E+00      0.  0.431E+00  0.104E+00  0.141E-02  0.633E-04   14   0   7    7  21  49   20  26  49    0.000    0.000       2
-  0   3565 01:00:00.35   0.9500A   1.9757  -1.1661   1.2617  0.072  0.00   0.000E+00      0.  0.431E+00  0.107E+00  0.153E-02  0.857E-04   22   7  79    2   8  49   18  11  48    0.000    0.000       2
+  0   1309 00:24:00.41   1.0200A   1.7685   1.0824   1.3410  0.066  0.00   0.000E+00      0.  0.418E+00  0.897E-01  0.172E-02  0.886E-04   31   4   6    2  32  49   20  15  49    0.000    0.000       2
+  0   1369 00:25:00.62   1.0100A   1.7922   1.1281   1.5206  0.068  0.00   0.000E+00      0.  0.410E+00  0.846E-01  0.177E-02  0.113E-03   25  39   0    4  31  49   20  26  49    0.000    0.000       2
+  0   1428 00:26:00.53   1.0000A   1.7922   1.0522   1.2577  0.080  0.00   0.000E+00      0.  0.414E+00  0.892E-01  0.170E-02  0.909E-04   17   7  58    2  31  49   20  24  49    0.000    0.000       2
+  0   1488 00:27:00.19   0.9830A   1.8317   1.0431   1.2971  0.080  0.00   0.000E+00      0.  0.410E+00  0.839E-01  0.150E-02  0.918E-04   30   0  56    2  33  49   20  13  49    0.000    0.000       2
+  0   1549 00:28:00.86   1.0200A   1.7587   1.2783   1.1737  0.080  0.00   0.000E+00      0.  0.412E+00  0.861E-01  0.155E-02  0.895E-04   37  35  14   17  22  49   20  19  49    0.000    0.000       2
+  0   1607 00:29:00.66   1.0700A   1.7517   1.0580   1.3334  0.069  0.00   0.000E+00      0.  0.413E+00  0.908E-01  0.174E-02  0.111E-03   29   2  78    7  31  49   20  18  49    0.000    0.000       2
+  0   1664 00:30:00.30   1.0200A   1.7577   1.0979   1.3304  0.069  0.00   0.000E+00      0.  0.415E+00  0.892E-01  0.163E-02  0.930E-04   11   5  74   13  31  49   20  14  49    0.000    0.000       2
+  0   1721 00:31:00.63   1.0300A   1.7493   1.0514   1.4114  0.064  0.00   0.000E+00      0.  0.414E+00  0.895E-01  0.168E-02  0.912E-04   24   2  60    5  27  49   20  17  49    0.000    0.000       2
+  0   1778 00:32:00.54   1.0700A   1.6982   1.0101   1.2918  0.077  0.00   0.000E+00      0.  0.412E+00  0.897E-01  0.168E-02  0.910E-04   22   1   0    2  32  49   20  25  49    0.000    0.000       2
+  0   1835 00:33:00.08   0.9870A   1.8237   1.1300   1.4105  0.069  0.00   0.000E+00      0.  0.410E+00  0.901E-01  0.162E-02  0.932E-04   21  12  50    2  32  49   20  13  49    0.000    0.000       2
+  0   1896 00:34:00.94   0.9630A   1.8683   0.9200   1.2868  0.074  0.00   0.000E+00      0.  0.419E+00  0.965E-01  0.140E-02  0.736E-04   27   0  14    1  31  49   20  20  49    0.000    0.000       2
+  0   1957 00:35:00.12   0.9490A   1.8959   1.1169   1.2910  0.072  0.00   0.000E+00      0.  0.417E+00  0.980E-01  0.136E-02  0.782E-04   22   0   4    2  31  49   20  21  49    0.000    0.000       2
+  0   2020 00:36:00.64   0.9250A   1.9828   1.0607   1.2856  0.070  0.00   0.000E+00      0.  0.427E+00  0.105E+00  0.133E-02  0.735E-04   34   1  79   17  30  49   20  17  49    0.000    0.000       2
+  0   2083 00:37:00.18   0.9690A   1.8993   1.0620   1.8102  0.064  0.00   0.000E+00      0.  0.424E+00  0.105E+00  0.156E-02  0.860E-04   30   1  78    7  30  49   20  16  49    0.000    0.000       2
+  0   2146 00:38:00.28   0.9890A   1.8208   1.1521   1.4853  0.066  0.00   0.000E+00      0.  0.433E+00  0.112E+00  0.166E-02  0.889E-04   13   3  73    3  31  49   20  13  49    0.000    0.000       2
+  0   2212 00:39:00.45   0.8990A   2.0024   0.9584   1.5011  0.068  0.00   0.000E+00      0.  0.433E+00  0.116E+00  0.166E-02  0.766E-04   32   3  35   11  21  49   20  15  49    0.000    0.000       2
+  0   2279 00:40:00.22   0.9140A   1.9690  -0.8731   1.3077  0.074  0.00   0.000E+00      0.  0.432E+00  0.113E+00  0.166E-02  0.659E-04   26   3  40    1   9  49   20  19  49    0.000    0.000       2
+  0   2346 00:41:00.51   0.8880A   2.0280   1.2081   1.4420  0.076  0.00   0.000E+00      0.  0.434E+00  0.114E+00  0.163E-02  0.817E-04   24   3  29    2  33  49   20  16  49    0.000    0.000       2
+  0   2414 00:42:00.31   0.9310A   1.9327   1.0908   1.5137  0.074  0.00   0.000E+00      0.  0.435E+00  0.116E+00  0.168E-02  0.820E-04   28   4  74    2  32  49   20  24  49    0.000    0.000       2
+  0   2478 00:43:00.11   0.9680A   1.8587   0.8737   1.2992  0.074  0.00   0.000E+00      0.  0.432E+00  0.113E+00  0.180E-02  0.694E-04   32   9  47    3  31  48   20  26  49    0.000    0.000       2
+  0   2543 00:44:00.60   0.9470A   1.9016  -0.9165   1.3273  0.074  0.00   0.000E+00      0.  0.440E+00  0.119E+00  0.173E-02  0.788E-04   40  37   0    1   9  49   20  25  49    0.000    0.000       2
+  0   2606 00:45:00.28   0.9360A   1.9228   0.9341   1.3538  0.069  0.00   0.000E+00      0.  0.438E+00  0.118E+00  0.195E-02  0.890E-04   31  39  16    3  31  42   20  11  49    0.000    0.000       2
+  0   2671 00:46:00.77   0.9420A   1.9107   1.5920   1.2623  0.065  0.00   0.000E+00      0.  0.431E+00  0.109E+00  0.195E-02  0.824E-04   33   2  69   11  30  49   20  14  49    0.000    0.000       2
+  0   2734 00:47:00.86   0.9460A   1.9037  -1.0030   1.5033  0.065  0.00   0.000E+00      0.  0.426E+00  0.102E+00  0.179E-02  0.953E-04   33  38   3   16   9  49   20  16  49    0.000    0.000       2
+  0   2798 00:48:00.90   0.9470A   1.8998  -1.0173   1.2036  0.070  0.00   0.000E+00      0.  0.422E+00  0.977E-01  0.166E-02  0.873E-04   32  38   7    7  10  49   20  20  49    0.000    0.000       2
+  0   2860 00:49:00.41   0.9920A   1.8138   1.0122   1.2194  0.072  0.00   0.000E+00      0.  0.425E+00  0.988E-01  0.162E-02  0.750E-04   24  38  57   23  22  53   20  26  49    0.000    0.000       2
+  0   2922 00:50:00.53   0.9490A   1.8969   1.0509   1.3286  0.071  0.00   0.000E+00      0.  0.420E+00  0.963E-01  0.167E-02  0.780E-04   16  38  77    1  36  50   20  25  49    0.000    0.000       2
+  0   2983 00:51:00.95   0.9860A   1.8264   1.0940   1.2941  0.069  0.00   0.000E+00      0.  0.424E+00  0.988E-01  0.173E-02  0.653E-04   11  37  58    1  33  49   20  26  49    0.000    0.000       2
+  0   3042 00:52:00.81   1.0600A   1.6908   1.0097   1.2368  0.067  0.00   0.000E+00      0.  0.419E+00  0.950E-01  0.174E-02  0.858E-04   24  34  63    2  31  49   20  22  49    0.000    0.000       2
+  0   3100 00:53:01.00   1.0200A   1.8859  -0.9508   1.3760  0.064  0.00   0.000E+00      0.  0.419E+00  0.969E-01  0.160E-02  0.709E-04   34  37  78   11   9  49   20  25  49    0.000    0.000       2
+  0   3160 00:54:00.25   1.0100A   1.7996  -0.8118   1.1846  0.064  0.00   0.000E+00      0.  0.423E+00  0.103E+00  0.161E-02  0.739E-04   29  38  78   23  13  62   20  13  49    0.000    0.000       2
+  0   3221 00:55:00.97   1.0000A   1.8501  -0.8726   1.3177  0.066  0.00   0.000E+00      0.  0.419E+00  0.999E-01  0.156E-02  0.805E-04   31  38  78    3   9  49   20  12  49    0.000    0.000       2
+  0   3282 00:56:00.48   0.9400A   1.9148  -0.7725   1.2973  0.070  0.00   0.000E+00      0.  0.423E+00  0.101E+00  0.146E-02  0.603E-04   24  36   2    8  15  40   20  27  49    0.000    0.000       2
+  0   3344 00:57:00.14   0.9770A   1.8423  -1.0224   1.2834  0.070  0.00   0.000E+00      0.  0.424E+00  0.103E+00  0.160E-02  0.792E-04   33  38  30    8  14  49   20  27  49    0.000    0.000       2
+  0   3406 00:58:00.04   0.9570A   1.8830  -1.1580   1.3461  0.073  0.00   0.000E+00      0.  0.428E+00  0.107E+00  0.165E-02  0.892E-04   26   2  79    3   8  49   20  14  49    0.000    0.000       2
+  0   3470 00:59:00.88   0.9590A   1.8777  -1.0590   1.2708  0.069  0.00   0.000E+00      0.  0.431E+00  0.110E+00  0.176E-02  0.766E-04   26  39  44    1   6  49   20  26  49    0.000    0.000       2
+  0   3534 01:00:00.70   0.9230A   1.9494   1.0107   1.5555  0.068  0.00   0.000E+00      0.  0.433E+00  0.108E+00  0.176E-02  0.894E-04   28  35  30    1  31  49   20  23  49    0.000    0.000       2