Index: /palm/trunk/SOURCE/biometeorology_mod.f90
===================================================================
--- /palm/trunk/SOURCE/biometeorology_mod.f90	(revision 4767)
+++ /palm/trunk/SOURCE/biometeorology_mod.f90	(revision 4768)
@@ -26,4 +26,7 @@
 ! -----------------
 ! $Id$
+! Enable 3D data output also with 64-bit precision
+!
+! 4633 2020-08-05 14:21:14Z suehring
 ! Bugfix in check for humidity
 !
@@ -1123,5 +1126,5 @@
     LOGICAL, INTENT(OUT) ::  found   !< Output found?
 
-    REAL(sp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf   !< Temp. result grid to return
+    REAL(wp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf   !< Temp. result grid to return
 !
 !-- Internal variables
Index: /palm/trunk/SOURCE/bulk_cloud_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/bulk_cloud_model_mod.f90	(revision 4767)
+++ /palm/trunk/SOURCE/bulk_cloud_model_mod.f90	(revision 4768)
@@ -24,4 +24,7 @@
 ! -----------------
 ! $Id$
+! Enable 3D data output also with 64-bit precision
+!
+! 4755 2020-10-21 15:09:15Z schwenkel
 ! Minor reformatting
 !
@@ -4574,5 +4577,5 @@
     REAL(wp) ::  fill_value = -999.0_wp  !< value for the _FillValue attribute
 
-    REAL(sp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do), INTENT(INOUT) ::  local_pf   !< local
+    REAL(wp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do), INTENT(INOUT) ::  local_pf   !< local
                                                         !< array to which output data is resorted to
 
Index: /palm/trunk/SOURCE/chemistry_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 4767)
+++ /palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 4768)
@@ -26,4 +26,7 @@
 ! -----------------
 ! $Id$
+! Enable 3D data output also with 64-bit precision
+!
+! 4731 2020-10-07 13:25:11Z schwenkel
 ! Move exchange_horiz from time_integration to modules
 !
@@ -1557,5 +1560,5 @@
     REAL(wp)             ::  fill_value   !<
 
-    REAL(sp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf
+    REAL(wp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf
 !
 !-- Local variables
Index: /palm/trunk/SOURCE/data_output_3d.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_3d.f90	(revision 4767)
+++ /palm/trunk/SOURCE/data_output_3d.f90	(revision 4768)
@@ -19,9 +19,12 @@
 ! Current revisions:
 ! ------------------
-! 
-! 
+!
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Enable 3D data output also with 64-bit precision
+! 
+! 4559 2020-06-11 08:51:48Z raasch
 ! file re-formatted to follow the PALM coding standard
 !
@@ -170,5 +173,5 @@
     REAL(wp)     ::  s_r3      !< sum( particle-radius**3 )
 
-    REAL(sp), DIMENSION(:,:,:), ALLOCATABLE ::  local_pf  !< output array
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  local_pf  !< output array
 
     REAL(wp), DIMENSION(:,:,:), POINTER ::  to_be_resorted  !< pointer to array which shall be
@@ -261,5 +264,5 @@
 !
 !--    Before each output, set array local_pf to fill value
-       local_pf = fill_value
+       local_pf = REAL( fill_value, KIND=wp )
 !
 !--    Set masking flag for topography for not resorted arrays
@@ -674,9 +677,11 @@
 !                count = (/ nxr-nxl+2, nyn-nys+2, nzt_do-nzb_do+1, 1 /) )
 !          ELSE
-             nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_do3d(av,ivar),                          &
-                                     local_pf(nxl:nxr,nys:nyn,nzb_do:nzt_do),                      &
-                                     start = (/ nxl+1, nys+1, nzb_do+1, do3d_time_count(av) /),    &
-                                     count = (/ nxr-nxl+1, nyn-nys+1, nzt_do-nzb_do+1, 1 /)        &
-                                   )
+!
+!--       Call for parallel runs
+          nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_do3d(av,ivar),                             &
+                                   local_pf(nxl:nxr,nys:nyn,nzb_do:nzt_do),                        &
+                                   start = (/ nxl+1, nys+1, nzb_do+1, do3d_time_count(av) /),      &
+                                   count = (/ nxr-nxl+1, nyn-nys+1, nzt_do-nzb_do+1, 1 /)          &
+                                 )
 !          ENDIF
           CALL netcdf_handle_error( 'data_output_3d', 386 )
@@ -685,4 +690,6 @@
 #else
 #if defined( __netcdf )
+!
+!--    Call for non-parallel runs
        nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_do3d(av,ivar),                                &
                                local_pf(nxl:nxr,nys:nyn,nzb_do:nzt_do),                            &
Index: /palm/trunk/SOURCE/diagnostic_output_quantities_mod.f90
===================================================================
--- /palm/trunk/SOURCE/diagnostic_output_quantities_mod.f90	(revision 4767)
+++ /palm/trunk/SOURCE/diagnostic_output_quantities_mod.f90	(revision 4768)
@@ -24,4 +24,7 @@
 ! -----------------
 ! $Id$
+! Enable 3D data output also with 64-bit precision
+!
+! 4757 2020-10-26 10:23:38Z schwenkel
 ! Implement relative humidity as diagnostic output quantity
 !
@@ -1201,5 +1204,5 @@
     REAL(wp) ::  fill_value       !< value for the _FillValue attribute
 
-    REAL(sp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf        !<
+    REAL(wp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf        !<
     REAL(wp), DIMENSION(:,:,:), POINTER ::                 to_be_resorted  !< points to array which needs to be resorted for output
 
Index: /palm/trunk/SOURCE/dynamics_mod.f90
===================================================================
--- /palm/trunk/SOURCE/dynamics_mod.f90	(revision 4767)
+++ /palm/trunk/SOURCE/dynamics_mod.f90	(revision 4768)
@@ -24,4 +24,7 @@
 ! -----------------
 ! $Id$
+! Enable 3D data output also with 64-bit precision
+!
+! 4760 2020-10-26 13:26:47Z schwenkel
 ! Implement relative humidity as diagnostic output quantity
 !
@@ -1839,5 +1842,5 @@
     REAL(wp), INTENT(IN) ::  fill_value    !< value for the _FillValue attribute
 
-    REAL(sp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf !<
+    REAL(wp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf !<
 
 !
Index: /palm/trunk/SOURCE/gust_mod.f90
===================================================================
--- /palm/trunk/SOURCE/gust_mod.f90	(revision 4767)
+++ /palm/trunk/SOURCE/gust_mod.f90	(revision 4768)
@@ -24,4 +24,7 @@
 ! -----------------
 ! $Id$
+! Enable 3D data output also with 64-bit precision
+!
+! 4646 2020-08-24 16:02:40Z raasch
 ! file re-formatted to follow the PALM coding standard
 !
@@ -543,5 +546,5 @@
        REAL(wp), INTENT(IN) ::  fill_value !< value for the _FillValue attribute
 
-       REAL(sp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do), INTENT(INOUT) ::  local_pf   !< local
+       REAL(wp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do), INTENT(INOUT) ::  local_pf   !< local
                                                                                         !< array to which output data is resorted to
 
Index: /palm/trunk/SOURCE/indoor_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/indoor_model_mod.f90	(revision 4767)
+++ /palm/trunk/SOURCE/indoor_model_mod.f90	(revision 4768)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Enable 3D data output also with 64-bit precision
+!
+! 4750 2020-10-16 14:27:48Z suehring
 ! - Namelist parameter added to switch-off/on the indoor model during wall/soil spinup
 ! - Bugfix in window-wall treatment during spinup - in the urban-surface model the window fraction
@@ -1996,5 +1999,5 @@
     REAL(wp), INTENT(IN) ::  fill_value !< value for the _FillValue attribute
 
-    REAL(sp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf !<
+    REAL(wp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf !<
 
     local_pf = fill_value
Index: /palm/trunk/SOURCE/land_surface_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 4767)
+++ /palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 4768)
@@ -24,4 +24,7 @@
 ! -----------------
 ! $Id$
+! Enable 3D data output also with 64-bit precision
+!
+! 4723 2020-10-06 15:16:11Z raasch
 ! file re-formatted to follow the PALM coding standard
 !
@@ -6223,5 +6226,5 @@
     REAL(wp) ::  fill_value = -999.0_wp    !< value for the _FillValue attribute
 
-    REAL(sp), DIMENSION(nxl:nxr,nys:nyn,nzb_soil:nzt_soil) ::  local_pf !<
+    REAL(wp), DIMENSION(nxl:nxr,nys:nyn,nzb_soil:nzt_soil) ::  local_pf !<
 
 
Index: /palm/trunk/SOURCE/module_interface.f90
===================================================================
--- /palm/trunk/SOURCE/module_interface.f90	(revision 4767)
+++ /palm/trunk/SOURCE/module_interface.f90	(revision 4768)
@@ -24,4 +24,7 @@
 ! -----------------
 ! $Id$
+! Enable 3D data output also with 64-bit precision
+!
+! 4757 2020-10-26 10:23:38Z schwenkel
 ! Implement doq calls
 !
@@ -1615,5 +1618,5 @@
     REAL(wp),          INTENT(IN)    ::  fill_value !< ToDo: refactor
 
-    REAL(sp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do), INTENT(INOUT) ::  local_pf
+    REAL(wp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do), INTENT(INOUT) ::  local_pf
 
 
Index: /palm/trunk/SOURCE/ocean_mod.f90
===================================================================
--- /palm/trunk/SOURCE/ocean_mod.f90	(revision 4767)
+++ /palm/trunk/SOURCE/ocean_mod.f90	(revision 4768)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Enable 3D data output also with 64-bit precision
+!
+! 4731 2020-10-07 13:25:11Z schwenkel
 ! Move exchange_horiz from time_integration to modules
 !
@@ -1121,5 +1124,5 @@
     REAL(wp) ::  fill_value = -999.0_wp  !< value for the _FillValue attribute
 
-    REAL(sp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf   !< local
+    REAL(wp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf   !< local
                                   !< array to which output data is resorted to
 
Index: /palm/trunk/SOURCE/plant_canopy_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/plant_canopy_model_mod.f90	(revision 4767)
+++ /palm/trunk/SOURCE/plant_canopy_model_mod.f90	(revision 4768)
@@ -27,4 +27,7 @@
 ! -----------------
 ! $Id$
+! Enable 3D data output also with 64-bit precision
+!
+! 4671 2020-09-09 20:27:58Z pavelkrc
 ! Implementation of downward facing USM and LSM surfaces
 ! 
@@ -783,5 +786,5 @@
 
     REAL(wp)     ::  fill_value !< fill value
-    REAL(sp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf !< data output array
+    REAL(wp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf !< data output array
 
 
Index: /palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/radiation_model_mod.f90	(revision 4767)
+++ /palm/trunk/SOURCE/radiation_model_mod.f90	(revision 4768)
@@ -28,4 +28,7 @@
 ! -----------------
 ! $Id$
+! Enable 3D data output also with 64-bit precision
+!
+! 4741 2020-10-14 14:32:50Z suehring
 ! Add option to force calculation of horizontal mean profiles independent on data output
 !
@@ -11639,5 +11642,5 @@
     REAL(wp)     ::  fill_value  !< value for the _FillValue attribute
 
-    REAL(sp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf !<
+    REAL(wp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf !<
 
     CHARACTER (len=varnamelength)                   :: var, surfid
Index: /palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- /palm/trunk/SOURCE/salsa_mod.f90	(revision 4767)
+++ /palm/trunk/SOURCE/salsa_mod.f90	(revision 4768)
@@ -26,4 +26,7 @@
 ! -----------------
 ! $Id$
+! Enable 3D data output also with 64-bit precision
+!
+! 4731 2020-10-07 13:25:11Z schwenkel
 ! Move exchange_horiz from time_integration to modules
 !
@@ -12059,5 +12062,5 @@
     REAL(wp) ::  temp_bin                 !< temporary array for calculating output variables
 
-    REAL(sp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf  !< local
+    REAL(wp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf  !< local
 
     found     = .TRUE.
Index: /palm/trunk/SOURCE/turbulence_closure_mod.f90
===================================================================
--- /palm/trunk/SOURCE/turbulence_closure_mod.f90	(revision 4767)
+++ /palm/trunk/SOURCE/turbulence_closure_mod.f90	(revision 4768)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Enable 3D data output also with 64-bit precision
+!
+! 4717 2020-09-30 22:27:40Z pavelkrc
 ! Fixes and optimizations of OpenMP parallelization, formatting of OpenMP
 ! directives (J. Resler)
@@ -1064,5 +1067,5 @@
     REAL(wp) ::  fill_value = -9999.0_wp  !< value for the _FillValue attribute
 
-    REAL(sp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf  !< local
+    REAL(wp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf  !< local
        !< array to which output data is resorted to
 
Index: /palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- /palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4767)
+++ /palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4768)
@@ -27,4 +27,7 @@
 ! -----------------
 ! $Id$
+! Enable 3D data output also with 64-bit precision
+!
+! 4750 2020-10-16 14:27:48Z suehring
 ! - bugfix in openmp directive
 ! - make t_green_h and t_green_v public (required in indoor model)
@@ -2455,6 +2458,6 @@
     LOGICAL, INTENT(OUT)           ::  found     !<
 
-    REAL(sp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf  !< sp - it has to correspond to module data_output_3d
-    REAL(sp), DIMENSION(nzb:nzt+1,nys:nyn,nxl:nxr)     ::  temp_pf   !< temp array for urban surface output procedure
+    REAL(wp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf  !< sp - it has to correspond to module data_output_3d
+    REAL(wp), DIMENSION(nzb:nzt+1,nys:nyn,nxl:nxr)     ::  temp_pf   !< temp array for urban surface output procedure
 
     found = .TRUE.
@@ -2523,5 +2526,5 @@
                 j = surf_usm_h(l)%j(m)
                 k = surf_usm_h(l)%k(m)
-                temp_pf(0,j,i) = MAX( temp_pf(0,j,i), REAL( k, KIND = sp) )
+                temp_pf(0,j,i) = MAX( temp_pf(0,j,i), REAL( k, KIND = wp) )
              ENDDO
           ELSE
@@ -2530,5 +2533,5 @@
                 j = surf_usm_v(l)%j(m)
                 k = surf_usm_v(l)%k(m)
-                temp_pf(0,j,i) = MAX( temp_pf(0,j,i), REAL( k, KIND = sp) + 1.0_sp )
+                temp_pf(0,j,i) = MAX( temp_pf(0,j,i), REAL( k, KIND = wp) + 1.0_sp )
              ENDDO
           ENDIF
Index: /palm/trunk/SOURCE/user_module.f90
===================================================================
--- /palm/trunk/SOURCE/user_module.f90	(revision 4767)
+++ /palm/trunk/SOURCE/user_module.f90	(revision 4768)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! -----------------
-! 
-! 
+!
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Enable 3D data output also with 64-bit precision
+! 
+! 4535 2020-05-15 12:07:23Z raasch
 ! bugfix for restart data format query
 ! 
@@ -970,5 +973,5 @@
 !    REAL(wp) ::  fill_value = -999.0_wp  !< value for the _FillValue attribute
 
-    REAL(sp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf  !<
+    REAL(wp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf  !<
 
 !