Index: /palm/trunk/SOURCE/data_output_particle_mod.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_particle_mod.f90	(revision 4778)
+++ /palm/trunk/SOURCE/data_output_particle_mod.f90	(revision 4779)
@@ -24,4 +24,7 @@
 ! -----------------
 ! $Id$
+! Avoid overlong lines and unused variables
+!
+! 4778 2020-11-09 13:40:05Z raasch
 ! Initial implementation (K. Ketelsen)
 !
@@ -494,9 +497,11 @@
          IF (part_io%iam_io_pe)   THEN
             IF(variables(i)%is_integer)   THEN
-               CALL  netcdf4_write_variable('parallel', file_id, variables(i)%var_id, bounds_start, value_counts, bounds_origin,        &
-                  .FALSE., values_int32_1d=out_buf_i, return_value=return_value)
+               CALL  netcdf4_write_variable('parallel', file_id, variables(i)%var_id, bounds_start,&
+                                             value_counts, bounds_origin,                          &
+                                             .FALSE., values_int32_1d=out_buf_i, return_value=return_value)
             ELSE
-               CALL  netcdf4_write_variable('parallel', file_id, variables(i)%var_id, bounds_start, value_counts, bounds_origin,        &
-                  .FALSE., values_real32_1d=out_buf_r, return_value=return_value)
+               CALL  netcdf4_write_variable('parallel', file_id, variables(i)%var_id, bounds_start,&
+                                             value_counts, bounds_origin,                          &
+                                            .FALSE., values_real32_1d=out_buf_r, return_value=return_value)
             ENDIF
          ENDIF
@@ -520,6 +525,7 @@
             time_axis_values(icount) = my_time(1)
          ELSE
-            CALL  netcdf4_write_variable('parallel', file_id, var_id%time, bounds_start(1:1), value_counts(1:1), bounds_origin(1:1),   &
-                                      .TRUE., values_realwp_1d=my_time, return_value=return_value)
+            CALL  netcdf4_write_variable('parallel', file_id, var_id%time, bounds_start(1:1),      &
+                                          value_counts(1:1), bounds_origin(1:1),                   &
+                                         .TRUE., values_realwp_1d=my_time, return_value=return_value)
          ENDIF
          DEALLOCATE(my_time)
@@ -531,8 +537,11 @@
    SUBROUTINE dop_finalize
       IMPLICIT NONE
-
+#if defined( __netcdf4 )
       INTEGER(iwp) :: var_len
+#endif
       INTEGER(iwp) :: return_value                !< Return value data_output_netcdf4 .. routines
+#if defined( __netcdf4 )
       INTEGER(iwp) :: ierr                        !< MPI error code
+#endif
 
       IF( win_prt_i /= -1)   THEN
@@ -927,9 +936,11 @@
             IF (part_io%iam_io_pe)   THEN
                IF(fix_variables(fix_ind)%is_integer)   THEN
-                  CALL netcdf4_init_variable( 'parallel', file_id, fix_variables(fix_ind)%var_id, fix_variables(fix_ind)%name, 'int32',  &
-                                                  dimension_ids(1:1), .FALSE., return_value )
+                  CALL netcdf4_init_variable( 'parallel', file_id, fix_variables(fix_ind)%var_id,  &
+                                              fix_variables(fix_ind)%name, 'int32',                &
+                                              dimension_ids(1:1), .FALSE., return_value )
                ELSE
-                  CALL netcdf4_init_variable( 'parallel', file_id, fix_variables(fix_ind)%var_id, fix_variables(fix_ind)%name, 'real32',  &
-                                                  dimension_ids(1:1), .FALSE., return_value )
+                  CALL netcdf4_init_variable( 'parallel', file_id, fix_variables(fix_ind)%var_id,  &
+                                               fix_variables(fix_ind)%name, 'real32',              &
+                                               dimension_ids(1:1), .FALSE., return_value )
                ENDIF
 
@@ -1124,13 +1135,13 @@
          IF (part_io%iam_io_pe)   THEN
             IF(fix_variables(i)%is_integer)   THEN
-               CALL  netcdf4_write_variable('parallel', file_id, fix_variables(i)%var_id, bounds_start, value_counts, bounds_origin,        &
-                  .FALSE., values_int32_1d=out_buf_i, return_value=return_value)
+               CALL  netcdf4_write_variable('parallel', file_id, fix_variables(i)%var_id, bounds_start, value_counts, &
+                                            bounds_origin, .FALSE., values_int32_1d=out_buf_i, return_value=return_value)
             ELSE
-               CALL  netcdf4_write_variable('parallel', file_id, fix_variables(i)%var_id, bounds_start, value_counts, bounds_origin,        &
-                  .FALSE., values_real32_1d=out_buf_r, return_value=return_value)
-            END IF
+               CALL  netcdf4_write_variable('parallel', file_id, fix_variables(i)%var_id, bounds_start, value_counts, &
+                                            bounds_origin, .FALSE., values_real32_1d=out_buf_r, return_value=return_value)
+            ENDIF
          ENDIF
          CALL  part_io%sm_node_barrier()
-      END DO
+      ENDDO
 
       RETURN