Index: palm/trunk/SOURCE/indoor_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/indoor_model_mod.f90	(revision 4768)
+++ palm/trunk/SOURCE/indoor_model_mod.f90	(revision 4780)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-!
+! Change parameters for summer_pars and winter_pars (responsible: S. Rissmann)
 !
 ! Former revisions:
@@ -369,46 +369,46 @@
     REAL(wp), DIMENSION(0:1,1:7) ::  summer_pars = RESHAPE( (/                & ! building_type 1
                                           0.5_wp,                             & ! basical airflow without occupancy of the room
-                                          2.0_wp,                             & ! additional airflow depend of occupancy of the room
+                                          1.5_wp,                             & ! additional airflow depend of occupancy of the room
                                           0.5_wp,                             & ! building_type 2: basical airflow without occupancy
                                                                                 ! of the room
-                                          2.0_wp,                             & ! additional airflow depend of occupancy of the room
-                                          0.8_wp,                             & ! building_type 3: basical airflow without occupancy
-                                                                                ! of the room
-                                          2.0_wp,                             & ! additional airflow depend of occupancy of the room
-                                          0.1_wp,                             & ! building_type 4: basical airflow without occupancy
+                                          1.5_wp,                             & ! additional airflow depend of occupancy of the room
+                                          0.5_wp,                             & ! building_type 3: basical airflow without occupancy
                                                                                 ! of the room
                                           1.5_wp,                             & ! additional airflow depend of occupancy of the room
-                                          0.1_wp,                             & ! building_type 5: basical airflow without occupancy
+                                          1.0_wp,                             & ! building_type 4: basical airflow without occupancy
                                                                                 ! of the room
-                                          1.5_wp,                             & ! additional airflow depend of occupancy of the room
-                                          0.1_wp,                             & ! building_type 6: basical airflow without occupancy
+                                          1.0_wp,                             & ! additional airflow depend of occupancy of the room
+                                          1.0_wp,                             & ! building_type 5: basical airflow without occupancy
                                                                                 ! of the room
-                                          1.5_wp,                             & ! additional airflow depend of occupancy of the room
-                                          0.1_wp,                             & ! building_type 7: basical airflow without occupancy
+                                          1.0_wp,                             & ! additional airflow depend of occupancy of the room
+                                          1.0_wp,                             & ! building_type 6: basical airflow without occupancy
                                                                                 ! of the room
-                                          1.5_wp                              & ! additional airflow depend of occupancy of the room
+                                          1.0_wp,                             & ! additional airflow depend of occupancy of the room
+                                          1.0_wp,                             & ! building_type 7: basical airflow without occupancy
+                                                                                ! of the room
+                                          1.0_wp                              & ! additional airflow depend of occupancy of the room
                                                            /), (/ 2, 7 /) )
 
     REAL(wp), DIMENSION(0:1,1:7) ::  winter_pars = RESHAPE( (/                & ! building_type 1
-                                          0.1_wp,                             & ! basical airflow without occupancy of the room
-                                          0.5_wp,                             & ! additional airflow depend of occupancy of the room
-                                          0.1_wp,                             & ! building_type 2: basical airflow without occupancy
+                                          0.5_wp,                             & ! basical airflow without occupancy of the room
+                                          0.0_wp,                             & ! additional airflow depend of occupancy of the room
+                                          0.5_wp,                             & ! building_type 2: basical airflow without occupancy
                                                                                 ! of the room
-                                          0.5_wp,                             & ! additional airflow depend of occupancy of the room
-                                          0.1_wp,                             & ! building_type 3: basical airflow without occupancy
+                                          0.0_wp,                             & ! additional airflow depend of occupancy of the room
+                                          0.5_wp,                             & ! building_type 3: basical airflow without occupancy
                                                                                 ! of the room
-                                          0.5_wp,                             & ! additional airflow depend of occupancy of the room
-                                          0.1_wp,                             & ! building_type 4: basical airflow without occupancy
+                                          0.0_wp,                             & ! additional airflow depend of occupancy of the room
+                                          0.2_wp,                             & ! building_type 4: basical airflow without occupancy
                                                                                 ! of the room
-                                          1.5_wp,                             & ! additional airflow depend of occupancy of the room
-                                          0.1_wp,                             & ! building_type 5: basical airflow without occupancy
+                                          0.8_wp,                             & ! additional airflow depend of occupancy of the room
+                                          0.2_wp,                             & ! building_type 5: basical airflow without occupancy
                                                                                 ! of the room
-                                          1.5_wp,                             & ! additional airflow depend of occupancy of the room
-                                          0.1_wp,                             & ! building_type 6: basical airflow without occupancy
+                                          0.8_wp,                             & ! additional airflow depend of occupancy of the room
+                                          0.2_wp,                             & ! building_type 6: basical airflow without occupancy
                                                                                 ! of the room
-                                          1.5_wp,                             & ! additional airflow depend of occupancy of the room
-                                          0.1_wp,                             & ! building_type 7: basical airflow without occupancy
+                                          0.8_wp,                             & ! additional airflow depend of occupancy of the room
+                                          0.2_wp,                             & ! building_type 7: basical airflow without occupancy
                                                                                 ! of the room
-                                          1.5_wp                              & ! additional airflow depend of occupancy of the room
+                                          0.8_wp                              & ! additional airflow depend of occupancy of the room
                                                            /), (/ 2, 7 /) )
 