Index: palm/trunk/TESTS/cases/urban_environment_restart/INPUT/urban_environment_restart_p3dr
===================================================================
--- palm/trunk/TESTS/cases/urban_environment_restart/INPUT/urban_environment_restart_p3dr	(revision 4671)
+++ palm/trunk/TESTS/cases/urban_environment_restart/INPUT/urban_environment_restart_p3dr	(revision 4782)
@@ -23,5 +23,5 @@
 !
 !-- Mode
-!------------------------------------------------------------------------------     
+!------------------------------------------------------------------------------
     humidity             = .T.,
     q_surface            = 0.001,
@@ -40,5 +40,5 @@
 !
 !-- Wall/soil spinup
-!------------------------------------------------------------------------------    
+!------------------------------------------------------------------------------
     spinup_time         = 1200.0,
     spinup_pt_mean      = 284.15,
@@ -49,5 +49,5 @@
 !
 !-- Topography
-!------------------------------------------------------------------------------    
+!------------------------------------------------------------------------------
     topography           = 'read_from_file',
 
@@ -94,12 +94,12 @@
                             'e', 'e*', '#km', '#l',
                             '#t_soil', '#m_soil', 'rad_lw_in', 'rad_lw_out',
-                            'kc_NO', 'kc_NO2', 'kc_O3', 'kc_PM10', 
+                            'kc_NO', 'kc_NO2', 'kc_O3', 'kc_PM10',
 !
 !-- 2D/3D output settings
 !------------------------------------------------------------------------------
-    do3d_at_begin      = .T., 
+    do3d_at_begin      = .T.,
     do2d_at_begin      = .T.,
 
-    dt_data_output     = 60.0, 
+    dt_data_output     = 60.0,
     dt_data_output_av  = 60.0,
     averaging_interval = 60.0,
@@ -127,6 +127,6 @@
                   'tsurf*_xy', 'tsurf*_xy_av',
                   'pcm_lad', 'pcm_heatrate', 'pcm_heatrate_av',
-                  'kc_NO', 'kc_NO2', 'kc_O3', 'kc_PM10', 
-                  'kc_NO_av', 'kc_NO2_av', 'kc_O3_av', 'kc_PM10_av', 
+                  'kc_NO', 'kc_NO2', 'kc_O3', 'kc_PM10',
+                  'kc_NO_av', 'kc_NO2_av', 'kc_O3_av', 'kc_PM10_av',
 
  / ! end of d3par namelist
@@ -148,7 +148,4 @@
      nrefsteps = 3,
 
-     rad_angular_discretization = .F.,
-     raytrace_mpi_rma = .F.,
-
   /
 
@@ -157,6 +154,6 @@
 !-- LAND SURFACE MODEL PARAMETER NAMELIST
 !   Documentation: https://palm.muk.uni-hannover.de/trac/wiki/doc/app/lsmpar
-!------------------------------------------------------------------------------- 
- &land_surface_parameters 
+!-------------------------------------------------------------------------------
+ &land_surface_parameters
 
     constant_roughness     = .T.,
@@ -168,8 +165,8 @@
 
     root_fraction          = 0.49, 0.26, 0.25, 0.0, 0.0, 0.0, 0.0, 0.0,
-    soil_temperature       = 277.15, 277.0, 277.0, 277.0, 277.0, 277.0, 277.0, 277.0, 
+    soil_temperature       = 277.15, 277.0, 277.0, 277.0, 277.0, 277.0, 277.0, 277.0,
     soil_moisture          = 0.30,   0.30,  0.30,  0.30,  0.30, 0.30,  0.30,  0.30,
     deep_soil_temperature  = 277.0,
-    
+
  / ! end of lsm_par namelist
 
@@ -184,5 +181,5 @@
 
  / ! end of urban_surface_par namelist
- 
+
 
 !-------------------------------------------------------------------------------
@@ -191,10 +188,10 @@
 !-------------------------------------------------------------------------------
  &plant_canopy_parameters
- 
+
     canopy_mode       = 'read_from_file',
     canopy_drag_coeff = 0.3,
-      
+
  / ! end of canopy_par namelist
- 
+
 
 !-------------------------------------------------------------------------------
@@ -207,10 +204,10 @@
     chem_gasphase_on           = .T.,
     call_chem_at_all_substeps  = .FALSE.,
-    
+
     photolysis_scheme          = 'simple',
 
     cs_name                    = 'NO', 'NO2', 'O3', 'PM10',
-    cs_surface                 = 0.02,  0.03, 0.02, 25.0e-9,   ! surface concentration of PM10, PM25 in kg m-3, 
-                                                               ! units for gases in ppm   
+    cs_surface                 = 0.02,  0.03, 0.02, 25.0e-9,   ! surface concentration of PM10, PM25 in kg m-3,
+                                                               ! units for gases in ppm
 !-- initial profiles (also for lateral boundaries if 'set_constant_profiles' is chosen)
 !-- units for PM: kg m-3, units for gases: ppm
@@ -218,5 +215,5 @@
     cs_profile(2,:)            =  0.030, 0.030, 0.020, 0.020, 0.020, 0.015, 0.015, 0.015, 0.015, 0.015, 0.010,
     cs_profile(3,:)            =  0.020, 0.020, 0.050, 0.050, 0.050, 0.050, 0.050, 0.050, 0.050, 0.050, 0.050,
-    cs_profile(1,:)            =  25.e-09, 25.e-09, 23.0e-09, 23.e-09, 23.e-09, 23.e-09, 23.e-09, 23.e-09, 22.e-09, 22.e-09, 22.0e-09, 
+    cs_profile(1,:)            =  25.e-09, 25.e-09, 23.0e-09, 23.e-09, 23.e-09, 23.e-09, 23.e-09, 23.e-09, 22.e-09, 22.e-09, 22.0e-09,
 
     cs_heights(1,:)            =  0.0,   5.0,   15.0,   25.0,  35.0,  45.0,  55.0,  65.0,  75.0,  85.0, 95.0,
@@ -227,10 +224,10 @@
     bc_cs_b                    = 'neumann',
     bc_cs_t                    = 'neumann',
-    
+
     emissions_anthropogenic    = .T.,
-    mode_emis                  = 'PARAMETERIZED',  ! emission depending on street type from static driver
+    emiss_lod                  = 0,  ! emission depending on street type from static driver
     surface_csflux_name        = 'NO',   'NO2',  'PM10',   !"cs" stands for chemical species
-    surface_csflux             = 4745.0, 1326.0, 2700.e-09,! surface emission of PM10, PM25 in kg m-2 d-1, 
-                                                           ! for gases in umol m-2 d-1 for PARAMETERIZED 
+    surface_csflux             = 4745.0, 1326.0, 2700.e-09,! surface emission of PM10, PM25 in kg m-2 d-1,
+                                                           ! for gases in umol m-2 d-1 for PARAMETERIZED
     emiss_factor_main          = 1.667,  1.667,  1.667,    ! emiss_factor_main*surface_csflux for emission on main streets
     emiss_factor_side          = 0.334,  0.334,  0.334,    !emiss_factor_side*surface_csflux for emission on side streets
@@ -239,5 +236,5 @@
     max_street_id  = 19,
 
-! -- KPP solver steering. For details  see comments in chem_gasphase_mod.f90, SUBROUTINE rosenbrock 
+! -- KPP solver steering. For details  see comments in chem_gasphase_mod.f90, SUBROUTINE rosenbrock
 !                         (or other solver subroutine, if another solver is chosen)
     icntrl(3)                  = 1,   ! solver ros2